<?php
//This file is used to process the order and send the data to PayPal.

function wpgft_clearSlate($content) {
	 //Stupid Magic Quotes
	$_POST = array_map( 'stripslashes_deep', $_POST ); 
	
	//Get The Paypal Options
	$wpgft_options_arr = get_option('wpgft_options');
	$paypal_id = $wpgft_options_arr['paypal_id'];
	$paypal_url = $wpgft_options_arr['paypal_url'];
	
	//Set the Default Values
	$error_Fname = "";
	$error_Lname = "";
	$error_email = "";
	$error_address = "";
	$error_state = "";
	$error_zip = "";
	$error_phone = "";
	$error_amount = "";
	$errorCombo = "";
	$ro = "";
	$form_act = "#";
	$error_amount = wpgft_DollarCheck($_POST['amount']);
	//Check to see if the form was submitted.
	if(isset($_POST['wpgft_purch'])) {
		
		//Start error checking.
		
		
		$phoneCombo = $_POST['orderPhoneArea'] . $_POST['orderPhoneExc'] . $_POST['orderPhoneNum'];
		$error_Fname = notBlank($_POST['orderFName'], "First Name");
		$error_Lname = notBlank($_POST['orderLName'], "Last Name");
		if(!is_email($_POST['orderEmail'])) {
			$error_email = "Email Address Invalid";
		}
		$error_address = notBlank($_POST['orderAdd'], "Address");
		$error_city = notBlank($_POST['orderCity'], "City");
		$error_state = notBlank($_POST['orderState'], "State");
		$error_zip = notBlank($_POST['orderZip'], "Zip");
		$error_phone = notBlank($phoneCombo, "Phone");
		if(!$error_phone) {
			$error_phone = phone_check($phoneCombo);
		}
		$errorCombo = $error_Fname . $error_Lname . $error_email . $error_address . $error_city . $error_state . $error_zip . $error_phone . $error_amount;
		
		//Check to see if there were errors, if everything is good then disable input fields.
		if(!$errorCombo) {
			$ro = 'readonly="true"';
			$form_act = $paypal_url;
			}
		}
	
		//get the current button information.
		$current_button = get_current_button($_POST['button_id']);
		$amount = $current_button['amount'];
		$description = $current_button['description'] ;//$current_button['description'];
		
		//Check to see if it was a custom amount, if so ignore the stored button amount.
		if($current_button['amount'] == 0 || $current_button['amount'] =="")  $amount = $_POST['amount'];
		?>
		<form id="wpgft_orderProc" class="wpgftOrder" method="Post" action="<?php echo $form_act ?>" enctype="multipart/form">
			<fieldset class="wpgft_fieldset">
				<dl class="wpgft_mainList">
					<div class="wpgft_titleBox">Your Order</div>
					<dt>Amount:</dt>
					<?php if( $error_amount ) {
					?>
					<dd><input type="text" name="amount" value="<?php echo $amount ?>" /> <input type="hidden" name="button_id" value="<?php echo esc_attr($_POST['button_id']) ?>" /><br /><span class="wpgft_error"><?php echo $error_amount ?></span></dd>
					<?php } else { ?>
					<dd><?php echo $amount ?><input type="hidden" name="amount" value="<?php echo $amount ?>" /><input type="hidden" name="button_id" value="<?php echo esc_attr($_POST['button_id']) ?>" /></dd>
					<?php } ?>
					<dt>Description:</dt>
					<dd><?php echo $description ?></dd>
				</dl>
				<dl class="wpgft_mainList">
					<div class="wpgft_titleBox">Your Information</div>
					<dt><span class="wpgft_req">*</span>First Name:</dt>
					<dd><input type="text" <?php echo $ro; ?> name="orderFName" id="orderFName" value="<?php echo esc_attr($_POST['orderFName']) ?>"/> <?php if($error_Fname) echo '<br /><span class="wpgft_error">'.$error_Fname.'</span>' ; ?> </dd>
					<dt><span class="wpgft_req">*</span>Last Name:</dt>
					<dd><input type="text" <?php echo $ro; ?> name="orderLName" id="orderLName" value="<?php echo esc_attr($_POST['orderLName']) ?>"/> <?php if($error_Lname) echo '<br /><span class="wpgft_error">'.$error_Lname.'</span>' ; ?> </dd>
					
					<dt><span class="wpgft_req">*</span>eMail:</dt>
					<dd><input type="text" <?php echo $ro; ?> name="orderEmail" id="orderEmail" value="<?php echo esc_attr($_POST['orderEmail']) ?>" /> <?php if($error_email) echo '<br /><span class="wpgft_error">'.$error_email.'</span>' ; ?></dd>
					<dt><span class="wpgft_req">*</span>Address:</dt>
					<dd><input type="text" <?php echo $ro; ?> name="orderAdd" id="orderAdd" value="<?php echo esc_attr($_POST['orderAdd']) ?>"/> <?php if($error_address) echo '<br /><span class="wpgft_error">'.$error_address.'</span>' ; ?></dd>
					<dt><span class="wpgft_req">*</span>City:</dt>
					<dd><input type="text" <?php echo $ro; ?> name="orderCity" id="orderCity" value="<?php echo esc_attr($_POST['orderCity']) ?>" /> <?php if($error_city) echo '<br /><span class="wpgft_error">'.$error_city.'</span>' ; ?></dd>
					<dt><span class="wpgft_req">*</span>State:</dt>
					<dd>
					<select name="orderState" <?php echo $ro; ?>>
						<option value="AL" <?php if($_POST['orderState'] == "AL") echo "selected"; ?>>Alabama</option>
						<option value="AK" <?php if($_POST['orderState'] == "AK") echo "selected"; ?>>Alaska</option>
						<option value="AZ" <?php if($_POST['orderState'] == "AZ") echo "selected"; ?>>Arizona</option>
						<option value="AR" <?php if($_POST['orderState'] == "AR") echo "selected"; ?>>Arkansas</option>
						<option value="CA" <?php if($_POST['orderState'] == "CA") echo "selected"; ?>>California</option>
						<option value="CO" <?php if($_POST['orderState'] == "CO") echo "selected"; ?>>Colorado</option>
						<option value="CT" <?php if($_POST['orderState'] == "CT") echo "selected"; ?>>Connecticut</option>
						<option value="DE" <?php if($_POST['orderState'] == "DE") echo "selected"; ?>>Delaware</option>
						<option value="FL" <?php if($_POST['orderState'] == "FL") echo "selected"; ?>>Florida</option>
						<option value="GA" <?php if($_POST['orderState'] == "GA") echo "selected"; ?>>Georgia</option>
						<option value="HI" <?php if($_POST['orderState'] == "HI") echo "selected"; ?>>Hawaii</option>
						<option value="ID" <?php if($_POST['orderState'] == "ID") echo "selected"; ?>>Idaho</option>
						<option value="IL" <?php if($_POST['orderState'] == "IL") echo "selected"; ?>>Illinois</option>
						<option value="IN" <?php if($_POST['orderState'] == "IN") echo "selected"; ?>>Indiana</option>
						<option value="IA" <?php if($_POST['orderState'] == "IA") echo "selected"; ?>>Iowa</option>
						<option value="KS" <?php if($_POST['orderState'] == "KS") echo "selected"; ?>>Kansas</option>
						<option value="KY" <?php if($_POST['orderState'] == "KY") echo "selected"; ?>>Kentucky</option>
						<option value="LA" <?php if($_POST['orderState'] == "LA") echo "selected"; ?>>Louisiana</option>
						<option value="ME" <?php if($_POST['orderState'] == "ME") echo "selected"; ?>>Maine</option>
						<option value="MD" <?php if($_POST['orderState'] == "MD") echo "selected"; ?>>Maryland</option>
						<option value="MA" <?php if($_POST['orderState'] == "MA") echo "selected"; ?>>Massachusetts</option>
						<option value="MI" <?php if($_POST['orderState'] == "MI") echo "selected"; ?>>Michigan</option>
						<option value="MN" <?php if($_POST['orderState'] == "MN") echo "selected"; ?>>Minnesota</option>
						<option value="MS" <?php if($_POST['orderState'] == "MS") echo "selected"; ?>>Mississippi</option>
						<option value="MO" <?php if($_POST['orderState'] == "MO") echo "selected"; ?>>Missouri</option>
						<option value="MT" <?php if($_POST['orderState'] == "MT") echo "selected"; ?>>Montana</option>
						<option value="NE" <?php if($_POST['orderState'] == "NE") echo "selected"; ?>>Nebraska</option>
						<option value="NV" <?php if($_POST['orderState'] == "NV") echo "selected"; ?>>Nevada</option>
						<option value="NH" <?php if($_POST['orderState'] == "NH") echo "selected"; ?>>New Hampshire</option>
						<option value="NJ" <?php if($_POST['orderState'] == "NJ") echo "selected"; ?>>New Jersey</option>
						<option value="NM" <?php if($_POST['orderState'] == "NM") echo "selected"; ?>>New Mexico</option>
						<option value="NY" <?php if($_POST['orderState'] == "NY") echo "selected"; ?>>New York</option>
						<option value="NC" <?php if($_POST['orderState'] == "NC") echo "selected"; ?>>North Carolina</option>
						<option value="ND" <?php if($_POST['orderState'] == "ND") echo "selected"; ?>>North Dakota</option>
						<option value="OH" <?php if($_POST['orderState'] == "OH") echo "selected"; ?>>Ohio</option>
						<option value="OK" <?php if($_POST['orderState'] == "OK") echo "selected"; ?>>Oklahoma</option>
						<option value="OR" <?php if($_POST['orderState'] == "OR") echo "selected"; ?>>Oregon</option>
						<option value="PA" <?php if($_POST['orderState'] == "PA") echo "selected"; ?>>Pennsylvania</option>
						<option value="RI" <?php if($_POST['orderState'] == "RI") echo "selected"; ?>>Rhode Island</option>
						<option value="SC" <?php if($_POST['orderState'] == "SC") echo "selected"; ?>>South Carolina</option>
						<option value="SD" <?php if($_POST['orderState'] == "SD") echo "selected"; ?>>South Dakota</option>
						<option value="TN" <?php if($_POST['orderState'] == "TN") echo "selected"; ?>>Tennessee</option>
						<option value="TX" <?php if($_POST['orderState'] == "TX") echo "selected"; ?>>Texas</option>
						<option value="UT" <?php if($_POST['orderState'] == "UT") echo "selected"; ?>>Utah</option>
						<option value="VT" <?php if($_POST['orderState'] == "VT") echo "selected"; ?>>Vermont</option>
						<option value="VA" <?php if($_POST['orderState'] == "VA") echo "selected"; ?>>Virginia</option>
						<option value="WA" <?php if($_POST['orderState'] == "WA") echo "selected"; ?>>Washington</option>
						<option value="WV" <?php if($_POST['orderState'] == "WV") echo "selected"; ?>>West Virginia</option>
						<option value="WI" <?php if($_POST['orderState'] == "WI") echo "selected"; ?>>Wisconsin</option>
						<option value="WY" <?php if($_POST['orderState'] == "WY") echo "selected"; ?>>Wyoming</option>
					</select>
							
					 <?php if($error_state) echo '<br /><span class="wpgft_error">'.$error_state.'</span>' ; ?></dd>
					<dt><span class="wpgft_req">*</span>Zip:</dt>
					<dd><input type="text" <?php echo $ro; ?> name="orderZip" id="orderZip" value="<?php echo esc_attr($_POST['orderZip']) ?>"/> <?php if($error_zip) echo '<br /><span class="wpgft_error">'.$error_zip.'</span>' ; ?></dd>
					<dt><span class="wpgft_req">*</span>Phone:</dt>
					<dd>(<input type="text" <?php echo $ro; ?> name="orderPhoneArea" id="orderPhoneArea" size="3" maxlength="3" value="<?php echo esc_attr($_POST['orderPhoneArea']) ?>" />)-<input type="text" <?php echo $ro; ?> name="orderPhoneExc" id="orderPhoneExc" size="3" maxlength="3" value="<?php echo esc_attr($_POST['orderPhoneExc']) ?>" />-<input type="text" <?php echo $ro; ?> name="orderPhoneNum" id="orderPhoneNum" size="5" maxlength="4" value="<?php echo esc_attr($_POST['orderPhoneNum']) ?>" /> <?php if($error_phone) echo '<br /><span class="wpgft_error">'.$error_phone.'</span>' ; ?></dd>
				</dl>
				<dl class="wpgft_mainList">
					<div class="wpgft_titleBox">Recipient Information</div>
					<dt>Name:</dt>
					<dd><input type="text" name="recpName" id="recpName" value="<?php echo esc_attr($_POST['recpName']) ?>" /></dd>
				</dl>
			</fieldset>
			<?php
				//Build out the fields for PayPal, As long as we are Error Free
				if(!$errorCombo && isset($_POST['wpgft_purch']) ) {
					$notifyURL = get_option('siteurl')."/?ipn_request='true'";
					$returnURL = get_option('siteurl')."/?paypal_return='true'";
					
					//Work around to get the phone number, PayPal IPN was failing to pass the contact_phone field
					$customFields = $_POST['recpName']."~".$_POST['orderPhoneArea']."-".$_POST['orderPhoneExc']."-".$_POST['orderPhoneNum'];
			?>
				<input type="hidden" name="cmd" value="_xclick" />
				<input type="hidden" name="notify_url" value="<?php echo $notifyURL; ?>" />
				<input type="hidden" name="return" value="<?php echo $returnURL; ?>" />
				<input type="hidden" name="business" value="<?php echo $paypal_id; ?>" />
				<input type="hidden" name="amount" value="<?php echo esc_attr($amount) ?>" />
				<input type="hidden" name="item_name" value="<?php echo esc_attr($description) ?>" />
				<input type="hidden" name="address_override" value="1" />
				<input type="hidden" name="first_name" value="<?php echo esc_attr($_POST['orderFName']) ?>" />
				<input type="hidden" name="last_name" value="<?php echo esc_attr($_POST['orderLName']) ?>" />
				<input type="hidden" name="email" value="<?php echo esc_attr($_POST['orderEmail']) ?>" />
				<input type="hidden" name="address1" value="<?php echo esc_attr($_POST['orderAdd']) ?>" />
				<input type="hidden" name="city" value="<?php echo esc_attr($_POST['orderCity']) ?>" />
				<input type="hidden" name="state" value="<?php echo esc_attr($_POST['orderState']) ?>" />
				<input type="hidden" name="zip" value="<?php echo esc_attr($_POST['orderZip']) ?>" />
				<input type="hidden" name="night_phone_a" value="<?php echo esc_attr($_POST['orderPhoneArea']) ?>" />
				<input type="hidden" name="night_phone_b" value="<?php echo esc_attr($_POST['orderPhoneExc']) ?>" />
				<input type="hidden" name="night_phone_c" value="<?php echo esc_attr($_POST['orderPhoneNum']) ?>" />
				<input type="hidden" name="custom" value="<?php echo esc_attr($customFields) ?>" />
				<input type="submit" value="Purchase Cert" name="wpgft_purch" class="button-primary">
				
			<?php
			} else {
			?>
			
			<input type="submit" value="Review Information" name="wpgft_purch" class="button-primary">
			<?php
			}
				$nonceID = 'wpgft_nonce_check'.$_POST['button_id'];
				if( function_exists('wp_nonce_field') ) wp_nonce_field($nonceID);
			?>
				
		</form>

		<?php
	
}
add_filter('the_content', 'wpgft_clearSlate');

function orderCSS() {
	global $wpgft_content_dir, $wpgft_content_url, $wpgft_plugin_dir;
	$fileLoc = $wpgft_content_url."/plugins/wp-gift-cert/css/wpgift.css";
	wp_register_style('wpgft-style', $fileLoc);
    wp_enqueue_style( 'wpgft-style');
}
add_action('wp_print_styles', 'orderCSS');

//Validation Functions (Gotta Check those inputs cause Users Suck
function notBlank($data, $field) {
	if($data == "") {
		$return_txt = "$field Required";
		return $return_txt;
	} else {
		return "";
	}
}

function phone_check($phoneCombo) {
	if(!is_numeric($phoneCombo)) return "Phone Invalid";
	if(strlen($phoneCombo) != 10) return "Phone Invalid";
	return "";
}

function wpgft_DollarCheck($amount) {
	if ( preg_match('/^((\$\d*)|(\$\d*\.\d{2})|(\d*)|(\d*\.\d{2}))$/', $amount) && $amount != 0 && $amount != ""){
		return "";
	} else {
		return "Amount Specified is ZERO or Invalid";
	}
	
}

?>